
/**
 * /!\ This file is automatically generated by QLALR from LogLexer.g.
 * /!\ Don't edit it!
 */

#include "LogLexer.hpp"

#include <QRegularExpression>

void LogLexer::consumeRule(int rule)
{
	switch(rule)
	{

	case 6:
		addStyleSym(Styles::Date | _currentTypeFlag, 1);
		addStyleSym(Styles::Date | _currentTypeFlag, 2);
		break;

	case 7:
		_currentTypeFlag = Styles::Debug;
		addStyleSym(Styles::Type | _currentTypeFlag, 1);
		break;

	case 8:
		_currentTypeFlag = Styles::Info;
		addStyleSym(Styles::Type | _currentTypeFlag, 1);
		addMarker(editor(), sym(1).position(), TextMarker::INFO);
		break;

	case 9:
		_currentTypeFlag = Styles::Warning;
		addStyleSym(Styles::Type | _currentTypeFlag, 1);
		addMarker(editor(), sym(1).position(), TextMarker::WARNING);
		break;

	case 10:
		_currentTypeFlag = Styles::Critical;
		addStyleSym(Styles::Type | _currentTypeFlag, 1);
		addMarker(editor(), sym(1).position(), TextMarker::ERROR);
		break;

	case 11:
		_currentTypeFlag = Styles::Fatal;
		addStyleSym(Styles::Type | _currentTypeFlag, 1);
		addMarker(editor(), sym(1).position(), TextMarker::ERROR);
		break;

	case 12:
		_currentTypeFlag = Styles::Error;
		addStyleSym(Styles::Type | _currentTypeFlag, 1);
		addMarker(editor(), sym(1).position(), TextMarker::ERROR);
		break;

	case 15:
		addStyleSym(Styles::Content | _currentTypeFlag, 1);
		break;

	case 16:
		addStyleSym(Styles::Content | _currentTypeFlag, 2);
		break;

	case 18:
		addStyleSym(Styles::FileInfo | _currentTypeFlag, 1);
		break;

	case 21:
		addStyleSym(Styles::FileInfo | _currentTypeFlag, 1);
		break;

	case 22:
		addStyleSym(Styles::FileInfo | _currentTypeFlag, 2);
		break;

	} // of the switch
}

int LogLexer::nextToken(QStringRef value)
{
	static const QRegularExpression datergx = ([]() -> QRegularExpression {
		QRegularExpression rgx(R"""(^[[:digit:]]{2}\/[[:digit:]]{2}\/[[:digit:]]{2,4}$)""");
		rgx.optimize();
		return rgx;
	})();
	static const QRegularExpression timergx = ([]() -> QRegularExpression {
		QRegularExpression rgx(R"""(^[[:digit:]]{2}:[[:digit:]]{2}:[[:digit:]]{2}$)""");
		rgx.optimize();
		return rgx;
	})();
	
	QStringRef tval = value.trimmed();

	if (tval.isEmpty())
		return LogLexer::WORD;

	// date
	if (tval.position() == _currentLine.position() && datergx.match(tval).hasMatch())
		return LogLexer::DATE;
	// time
	else if (timergx.match(tval).hasMatch())
		return LogLexer::TIME;
	// keywords
	else if (value.position() == _currentLine.position() && _currentLine.startsWith(LogLexer::spell[LogLexer::AT]))
		return LogLexer::AT;
	else if (tval == LogLexer::spell[LogLexer::DEBUG])
		return LogLexer::DEBUG;
	else if (tval == LogLexer::spell[LogLexer::INFO])
		return LogLexer::INFO;
	else if (tval == LogLexer::spell[LogLexer::WARNING])
		return LogLexer::WARNING;
	else if (tval == LogLexer::spell[LogLexer::CRITICAL])
		return LogLexer::CRITICAL;
	else if (tval == LogLexer::spell[LogLexer::FATAL])
		return LogLexer::FATAL;
	else if (tval == LogLexer::spell[LogLexer::ERROR])
		return LogLexer::ERROR;

	return LogLexer::WORD;
}
